Index: src/edu/ucsb/nceas/metacat/dataone/MNodeService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/dataone/MNodeService.java	(revision 8809)
+++ src/edu/ucsb/nceas/metacat/dataone/MNodeService.java	(revision 8810)
@@ -55,12 +55,12 @@
 
 import org.apache.commons.io.IOUtils;
 import org.apache.log4j.Logger;
-import org.dataone.client.CNode;
-import org.dataone.client.D1Client;
-import org.dataone.client.MNode;
-import org.dataone.client.ObjectFormatCache;
+import org.dataone.client.v2.CNode;
+import org.dataone.client.v2.itk.D1Client;
+import org.dataone.client.v2.MNode;
+import org.dataone.client.v2.formats.ObjectFormatCache;
 import org.dataone.client.auth.CertificateManager;
-import org.dataone.client.formats.ObjectFormatInfo;
+import org.dataone.client.v2.formats.ObjectFormatInfo;
 import org.dataone.configuration.Settings;
 import org.dataone.ore.ResourceMapFactory;
 import org.dataone.service.exceptions.BaseException;
@@ -75,27 +75,30 @@
 import org.dataone.service.exceptions.ServiceFailure;
 import org.dataone.service.exceptions.SynchronizationFailed;
 import org.dataone.service.exceptions.UnsupportedType;
-import org.dataone.service.mn.tier1.v1.MNCore;
-import org.dataone.service.mn.tier1.v1.MNRead;
-import org.dataone.service.mn.tier2.v1.MNAuthorization;
-import org.dataone.service.mn.tier3.v1.MNStorage;
-import org.dataone.service.mn.tier4.v1.MNReplication;
-import org.dataone.service.mn.v1.MNQuery;
+import org.dataone.service.mn.tier1.v2.MNCore;
+import org.dataone.service.mn.tier1.v2.MNRead;
+import org.dataone.service.mn.tier2.v2.MNAuthorization;
+import org.dataone.service.mn.tier3.v2.MNStorage;
+import org.dataone.service.mn.tier4.v2.MNReplication;
+import org.dataone.service.mn.v2.MNPackage;
+import org.dataone.service.mn.v2.MNQuery;
+import org.dataone.service.mn.v2.MNView;
 import org.dataone.service.types.v1.AccessRule;
 import org.dataone.service.types.v1.Checksum;
 import org.dataone.service.types.v1.DescribeResponse;
 import org.dataone.service.types.v1.Event;
 import org.dataone.service.types.v1.Identifier;
-import org.dataone.service.types.v1.Log;
-import org.dataone.service.types.v1.LogEntry;
+import org.dataone.service.types.v2.Log;
+import org.dataone.service.types.v2.LogEntry;
+import org.dataone.service.types.v2.OptionList;
 import org.dataone.service.types.v1.MonitorInfo;
 import org.dataone.service.types.v1.MonitorList;
-import org.dataone.service.types.v1.Node;
-import org.dataone.service.types.v1.NodeList;
+import org.dataone.service.types.v2.Node;
+import org.dataone.service.types.v2.NodeList;
 import org.dataone.service.types.v1.NodeReference;
 import org.dataone.service.types.v1.NodeState;
 import org.dataone.service.types.v1.NodeType;
-import org.dataone.service.types.v1.ObjectFormat;
+import org.dataone.service.types.v2.ObjectFormat;
 import org.dataone.service.types.v1.ObjectFormatIdentifier;
 import org.dataone.service.types.v1.ObjectList;
 import org.dataone.service.types.v1.Permission;
@@ -107,7 +110,7 @@
 import org.dataone.service.types.v1.Session;
 import org.dataone.service.types.v1.Subject;
 import org.dataone.service.types.v1.Synchronization;
-import org.dataone.service.types.v1.SystemMetadata;
+import org.dataone.service.types.v2.SystemMetadata;
 import org.dataone.service.types.v1.util.AuthUtils;
 import org.dataone.service.types.v1.util.ChecksumUtil;
 import org.dataone.service.types.v1_1.QueryEngineDescription;
@@ -141,6 +144,7 @@
 import edu.ucsb.nceas.metacat.shared.MetacatUtilException;
 import edu.ucsb.nceas.metacat.util.DeleteOnCloseFileInputStream;
 import edu.ucsb.nceas.metacat.util.DocumentUtil;
+import edu.ucsb.nceas.metacat.util.SkinUtil;
 import edu.ucsb.nceas.metacat.util.SystemUtil;
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 import edu.ucsb.nceas.utilities.XMLUtilities;
@@ -177,7 +181,7 @@
  * 
  */
 public class MNodeService extends D1NodeService 
-    implements MNAuthorization, MNCore, MNRead, MNReplication, MNStorage, MNQuery {
+    implements MNAuthorization, MNCore, MNRead, MNReplication, MNStorage, MNQuery, MNView, MNPackage {
 
     //private static final String PATHQUERY = "pathquery";
 	public static final String UUID_SCHEME = "UUID";
@@ -788,7 +792,7 @@
      * @throws NotImplemented
      */
     @Override
-    public ObjectList listObjects(Session session, Date startTime, Date endTime, ObjectFormatIdentifier objectFormatId, Boolean replicaStatus, Integer start,
+    public ObjectList listObjects(Session session, Date startTime, Date endTime, ObjectFormatIdentifier objectFormatId, Identifier identifier, Boolean replicaStatus, Integer start,
             Integer count) throws NotAuthorized, InvalidRequest, NotImplemented, ServiceFailure, InvalidToken {
 
         ObjectList objectList = null;
@@ -962,64 +966,8 @@
         }
     }
 
-    /**
-     * Returns the number of operations that have been serviced by the node 
-     * over time periods of one and 24 hours.
-     * 
-     * @param session - the Session object containing the credentials for the Subject
-     * @param period - An ISO8601 compatible DateTime range specifying the time 
-     *                 range for which to return operation statistics.
-     * @param requestor - Limit to operations performed by given requestor identity.
-     * @param event -  Enumerated value indicating the type of event being examined
-     * @param format - Limit to events involving objects of the specified format
-     * 
-     * @return the desired log records
-     * 
-     * @throws InvalidToken
-     * @throws ServiceFailure
-     * @throws NotAuthorized
-     * @throws InvalidRequest
-     * @throws NotImplemented
-     */
-    public MonitorList getOperationStatistics(Session session, Date startTime, 
-        Date endTime, Subject requestor, Event event, ObjectFormatIdentifier formatId)
-        throws NotImplemented, ServiceFailure, NotAuthorized, InsufficientResources, UnsupportedType {
+    
 
-        MonitorList monitorList = new MonitorList();
-
-        try {
-
-            // get log records first
-            Log logs = getLogRecords(session, startTime, endTime, event, null, 0, null);
-
-            // TODO: aggregate by day or hour -- needs clarification
-            int count = 1;
-            for (LogEntry logEntry : logs.getLogEntryList()) {
-                Identifier pid = logEntry.getIdentifier();
-                Date logDate = logEntry.getDateLogged();
-                // if we are filtering by format
-                if (formatId != null) {
-                    SystemMetadata sysmeta = HazelcastService.getInstance().getSystemMetadataMap().get(pid);
-                    if (!sysmeta.getFormatId().getValue().equals(formatId.getValue())) {
-                        // does not match
-                        continue;
-                    }
-                }
-                MonitorInfo item = new MonitorInfo();
-                item.setCount(count);
-                item.setDate(new java.sql.Date(logDate.getTime()));
-                monitorList.addMonitorInfo(item);
-
-            }
-        } catch (Exception e) {
-            e.printStackTrace();
-            throw new ServiceFailure("2081", "Could not retrieve statistics: " + e.getMessage());
-        }
-
-        return monitorList;
-
-    }
-
     /**
      * A callback method used by a CN to indicate to a MN that it cannot 
      * complete synchronization of the science metadata identified by pid.  Log
@@ -1398,132 +1346,12 @@
 		return identifier;
 	}
 
-	@Override
-	public boolean isAuthorized(Identifier pid, Permission permission)
-			throws ServiceFailure, InvalidRequest, InvalidToken, NotFound,
-			NotAuthorized, NotImplemented {
+	
 
-		return isAuthorized(null, pid, permission);
-	}
-
 	@Override
-	public boolean systemMetadataChanged(Identifier pid, long serialVersion, Date dateSysMetaLastModified)
+	public QueryEngineDescription getQueryEngineDescription(Session session, String engine)
 			throws InvalidToken, ServiceFailure, NotAuthorized, NotImplemented,
-			InvalidRequest {
-
-		return systemMetadataChanged(null, pid, serialVersion, dateSysMetaLastModified);
-	}
-
-	@Override
-	public Log getLogRecords(Date fromDate, Date toDate, Event event, String pidFilter,
-			Integer start, Integer count) throws InvalidRequest, InvalidToken,
-			NotAuthorized, NotImplemented, ServiceFailure {
-
-		return getLogRecords(null, fromDate, toDate, event, pidFilter, start, count);
-	}
-
-	@Override
-	public DescribeResponse describe(Identifier pid) throws InvalidToken,
-			NotAuthorized, NotImplemented, ServiceFailure, NotFound {
-
-		return describe(null, pid);
-	}
-
-	@Override
-	public InputStream get(Identifier pid) throws InvalidToken, NotAuthorized,
-			NotImplemented, ServiceFailure, NotFound, InsufficientResources {
-
-		return get(null, pid);
-	}
-
-	@Override
-	public Checksum getChecksum(Identifier pid, String algorithm)
-			throws InvalidRequest, InvalidToken, NotAuthorized, NotImplemented,
-			ServiceFailure, NotFound {
-
-		return getChecksum(null, pid, algorithm);
-	}
-
-	@Override
-	public SystemMetadata getSystemMetadata(Identifier pid)
-			throws InvalidToken, NotAuthorized, NotImplemented, ServiceFailure,
 			NotFound {
-
-		return getSystemMetadata(null, pid);
-	}
-
-	@Override
-	public ObjectList listObjects(Date startTime, Date endTime,
-			ObjectFormatIdentifier objectFormatId, Boolean replicaStatus, Integer start,
-			Integer count) throws InvalidRequest, InvalidToken, NotAuthorized,
-			NotImplemented, ServiceFailure {
-
-		return listObjects(null, startTime, endTime, objectFormatId, replicaStatus, start, count);
-	}
-
-	@Override
-	public boolean synchronizationFailed(SynchronizationFailed syncFailed)
-			throws InvalidToken, NotAuthorized, NotImplemented, ServiceFailure {
-
-		return synchronizationFailed(null, syncFailed);
-	}
-
-	@Override
-	public InputStream getReplica(Identifier pid) throws InvalidToken,
-			NotAuthorized, NotImplemented, ServiceFailure, NotFound,
-			InsufficientResources {
-
-		return getReplica(null, pid);
-	}
-
-	@Override
-	public boolean replicate(SystemMetadata sysmeta, NodeReference sourceNode)
-			throws NotImplemented, ServiceFailure, NotAuthorized,
-			InvalidRequest, InvalidToken, InsufficientResources,
-			UnsupportedType {
-
-		return replicate(null, sysmeta, sourceNode);
-	}
-
-	@Override
-	public Identifier create(Identifier pid, InputStream object,
-			SystemMetadata sysmeta) throws IdentifierNotUnique,
-			InsufficientResources, InvalidRequest, InvalidSystemMetadata,
-			InvalidToken, NotAuthorized, NotImplemented, ServiceFailure,
-			UnsupportedType {
-
-		return create(null, pid, object, sysmeta);
-	}
-
-	@Override
-	public Identifier delete(Identifier pid) throws InvalidToken,
-			ServiceFailure, NotAuthorized, NotFound, NotImplemented {
-
-		return delete(null, pid);
-	}
-
-	@Override
-	public Identifier generateIdentifier(String scheme, String fragment)
-			throws InvalidToken, ServiceFailure, NotAuthorized, NotImplemented,
-			InvalidRequest {
-
-		return generateIdentifier(null, scheme, fragment);
-	}
-
-	@Override
-	public Identifier update(Identifier pid, InputStream object,
-			Identifier newPid, SystemMetadata sysmeta) throws IdentifierNotUnique,
-			InsufficientResources, InvalidRequest, InvalidSystemMetadata,
-			InvalidToken, NotAuthorized, NotImplemented, ServiceFailure,
-			UnsupportedType, NotFound {
-
-		return update(null, pid, object, newPid, sysmeta);
-	}
-
-	@Override
-	public QueryEngineDescription getQueryEngineDescription(String engine)
-			throws InvalidToken, ServiceFailure, NotAuthorized, NotImplemented,
-			NotFound {
 	    if(engine != null && engine.equals(EnabledQueryEngines.PATHQUERYENGINE)) {
 	        if(!EnabledQueryEngines.getInstance().isEnabled(EnabledQueryEngines.PATHQUERYENGINE)) {
                 throw new NotImplemented("0000", "MNodeService.query - the query engine "+engine +" hasn't been implemented or has been disabled.");
@@ -1569,7 +1397,7 @@
 	}
 
 	@Override
-	public QueryEngineList listQueryEngines() throws InvalidToken,
+	public QueryEngineList listQueryEngines(Session session) throws InvalidToken,
 			ServiceFailure, NotAuthorized, NotImplemented {
 		QueryEngineList qel = new QueryEngineList();
 		//qel.addQueryEngine(EnabledQueryEngines.PATHQUERYENGINE);
@@ -1582,7 +1410,7 @@
 	}
 
 	@Override
-	public InputStream query(String engine, String query) throws InvalidToken,
+	public InputStream query(Session session, String engine, String query) throws InvalidToken,
 			ServiceFailure, NotAuthorized, InvalidRequest, NotImplemented,
 			NotFound {
 	    String user = Constants.SUBJECT_PUBLIC;
@@ -1855,7 +1683,7 @@
 				query = "fl=id,resourceMap&wt=xml&q=resourceMap:[* TO *]+id:\"" + pid + "\"";
 			}
 			
-			InputStream results = this.query("solr", query);
+			InputStream results = this.query(null, "solr", query);
 			org.w3c.dom.Node rootNode = XMLUtilities.getXMLReaderAsDOMTreeRootNode(new InputStreamReader(results, "UTF-8"));
 			//String resultString = XMLUtilities.getDOMTreeAsString(rootNode);
 			org.w3c.dom.NodeList nodeList = XMLUtilities.getNodeListWithXPath(rootNode, "//arr[@name=\"resourceMap\"]/str");
@@ -1875,17 +1703,11 @@
 		return retList;
 	}
 	
-	/**
-	 * Packages the given package in a Bagit collection for download
-	 * @param pid
-	 * @throws NotImplemented 
-	 * @throws NotFound 
-	 * @throws NotAuthorized 
-	 * @throws ServiceFailure 
-	 * @throws InvalidToken 
-	 */
-	public InputStream getPackage(Session session, Identifier pid) throws InvalidToken, ServiceFailure, NotAuthorized, NotFound, NotImplemented {
-		
+
+	@Override
+	public InputStream getPackage(Session session, ObjectFormatIdentifier formatId,
+			Identifier pid) throws InvalidToken, ServiceFailure,
+			NotAuthorized, InvalidRequest, NotImplemented, NotFound {
 		InputStream bagInputStream = null;
 		BagFactory bagFactory = new BagFactory();
 		Bag bag = bagFactory.createBag();
@@ -2145,24 +1967,28 @@
 		}
 		
 		return bagInputStream;
+	}
 
+	@Override
+	public OptionList listViews(Session arg0) throws InvalidToken,
+			ServiceFailure, NotAuthorized, InvalidRequest, NotImplemented {
+		OptionList views = new OptionList();
+		Vector<String> skinNames = null;
+		try {
+			skinNames = SkinUtil.getSkinNames();
+		} catch (PropertyNotFoundException e) {
+			throw new ServiceFailure("2841", e.getMessage());
+		}
+		for (String skinName: skinNames) {
+			views.addOption(skinName);
+		}
+		return views;
 	}
-	
-	/**
-	 * Get a rendered view of the object identified by pid.
-	 * Uses the registered format given by the format parameter.
-	 * Typically, this is structured HTML that can be styled with CSS.
-	 * @param session
-	 * @param pid
-	 * @param format
-	 * @return
-	 * @throws InvalidToken
-	 * @throws ServiceFailure
-	 * @throws NotAuthorized
-	 * @throws NotFound
-	 * @throws NotImplemented
-	 */
-	public InputStream getView(Session session, Identifier pid, String format) throws InvalidToken, ServiceFailure, NotAuthorized, NotFound, NotImplemented {
+
+	@Override
+	public InputStream view(Session session, String format, Identifier pid)
+			throws InvalidToken, ServiceFailure, NotAuthorized, InvalidRequest,
+			NotImplemented, NotFound {
 		InputStream resultInputStream = null;
 		
 		SystemMetadata sysMeta = this.getSystemMetadata(session, pid);
@@ -2231,7 +2057,6 @@
 		}
 		
 		return resultInputStream;
-		
 	}	
     
 }
Index: src/edu/ucsb/nceas/metacat/dataone/CNodeService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/dataone/CNodeService.java	(revision 8809)
+++ src/edu/ucsb/nceas/metacat/dataone/CNodeService.java	(revision 8810)
@@ -34,13 +34,13 @@
 import javax.servlet.http.HttpServletRequest;
 
 import org.apache.log4j.Logger;
-import org.dataone.client.CNode;
-import org.dataone.client.D1Client;
-import org.dataone.client.MNode;
-import org.dataone.service.cn.v1.CNAuthorization;
-import org.dataone.service.cn.v1.CNCore;
-import org.dataone.service.cn.v1.CNRead;
-import org.dataone.service.cn.v1.CNReplication;
+import org.dataone.client.v2.CNode;
+import org.dataone.client.v2.itk.D1Client;
+import org.dataone.client.v2.MNode;
+import org.dataone.service.cn.v2.CNAuthorization;
+import org.dataone.service.cn.v2.CNCore;
+import org.dataone.service.cn.v2.CNRead;
+import org.dataone.service.cn.v2.CNReplication;
 import org.dataone.service.exceptions.BaseException;
 import org.dataone.service.exceptions.IdentifierNotUnique;
 import org.dataone.service.exceptions.InsufficientResources;
@@ -59,14 +59,14 @@
 import org.dataone.service.types.v1.DescribeResponse;
 import org.dataone.service.types.v1.Event;
 import org.dataone.service.types.v1.Identifier;
-import org.dataone.service.types.v1.Log;
-import org.dataone.service.types.v1.Node;
-import org.dataone.service.types.v1.NodeList;
+import org.dataone.service.types.v2.Log;
+import org.dataone.service.types.v2.Node;
+import org.dataone.service.types.v2.NodeList;
 import org.dataone.service.types.v1.NodeReference;
 import org.dataone.service.types.v1.NodeType;
-import org.dataone.service.types.v1.ObjectFormat;
+import org.dataone.service.types.v2.ObjectFormat;
 import org.dataone.service.types.v1.ObjectFormatIdentifier;
-import org.dataone.service.types.v1.ObjectFormatList;
+import org.dataone.service.types.v2.ObjectFormatList;
 import org.dataone.service.types.v1.ObjectList;
 import org.dataone.service.types.v1.ObjectLocationList;
 import org.dataone.service.types.v1.Permission;
@@ -75,8 +75,8 @@
 import org.dataone.service.types.v1.ReplicationStatus;
 import org.dataone.service.types.v1.Session;
 import org.dataone.service.types.v1.Subject;
-import org.dataone.service.types.v1.SystemMetadata;
-import org.dataone.service.types.v1.util.ServiceMethodRestrictionUtil;
+import org.dataone.service.types.v2.SystemMetadata;
+import org.dataone.service.types.v2.util.ServiceMethodRestrictionUtil;
 import org.dataone.service.types.v1_1.QueryEngineDescription;
 import org.dataone.service.types.v1_1.QueryEngineList;
 
@@ -84,6 +84,7 @@
 import edu.ucsb.nceas.metacat.IdentifierManager;
 import edu.ucsb.nceas.metacat.McdbDocNotFoundException;
 import edu.ucsb.nceas.metacat.dataone.hazelcast.HazelcastService;
+import edu.ucsb.nceas.metacat.index.MetacatSolrIndex;
 
 /**
  * Represents Metacat's implementation of the DataONE Coordinating Node 
@@ -1729,7 +1730,7 @@
    */
   @Override
   public ObjectList listObjects(Session session, Date startTime, 
-      Date endTime, ObjectFormatIdentifier formatid, Boolean replicaStatus,
+      Date endTime, ObjectFormatIdentifier formatid, Identifier identifier, Boolean replicaStatus,
       Integer start, Integer count)
       throws InvalidRequest, InvalidToken, NotAuthorized, NotImplemented,
       ServiceFailure {
@@ -1834,203 +1835,132 @@
   }
 
 	@Override
-	public boolean isAuthorized(Identifier pid, Permission permission)
-			throws ServiceFailure, InvalidToken, NotFound, NotAuthorized,
-			NotImplemented, InvalidRequest {
-		
-		return isAuthorized(null, pid, permission);
-	}
-	
-	@Override
-	public boolean setAccessPolicy(Identifier pid, AccessPolicy accessPolicy, long serialVersion)
-			throws InvalidToken, NotFound, NotImplemented, NotAuthorized,
-			ServiceFailure, InvalidRequest, VersionMismatch {
-		
-		return setAccessPolicy(null, pid, accessPolicy, serialVersion);
-	}
-	
-	@Override
-	public Identifier setRightsHolder(Identifier pid, Subject userId, long serialVersion)
-			throws InvalidToken, ServiceFailure, NotFound, NotAuthorized,
-			NotImplemented, InvalidRequest, VersionMismatch {
-		
-		return setRightsHolder(null, pid, userId, serialVersion);
-	}
-	
-	@Override
-	public Identifier create(Identifier pid, InputStream object, SystemMetadata sysmeta)
-			throws InvalidToken, ServiceFailure, NotAuthorized,
-			IdentifierNotUnique, UnsupportedType, InsufficientResources,
-			InvalidSystemMetadata, NotImplemented, InvalidRequest {
+	public QueryEngineDescription getQueryEngineDescription(Session session,
+			String queryEngine) throws InvalidToken, ServiceFailure, NotAuthorized,
+			NotImplemented, NotFound {
+		throw new NotImplemented("0000", "CN query services are not implemented in Metacat.");
 
-		return create(null, pid, object, sysmeta);
 	}
 	
 	@Override
-	public Identifier delete(Identifier pid) throws InvalidToken, ServiceFailure,
-			NotAuthorized, NotFound, NotImplemented {
+	public QueryEngineList listQueryEngines(Session session) throws InvalidToken,
+			ServiceFailure, NotAuthorized, NotImplemented {
+		throw new NotImplemented("0000", "CN query services are not implemented in Metacat.");
 
-		return delete(null, pid);
 	}
 	
 	@Override
-	public Identifier generateIdentifier(String scheme, String fragment)
-			throws InvalidToken, ServiceFailure, NotAuthorized, NotImplemented,
-			InvalidRequest {
+	public InputStream query(Session session, String queryEngine, String query)
+			throws InvalidToken, ServiceFailure, NotAuthorized, InvalidRequest,
+			NotImplemented, NotFound {
+		throw new NotImplemented("0000", "CN query services are not implemented in Metacat.");
 
-		return generateIdentifier(null, scheme, fragment);
 	}
 	
 	@Override
-	public Log getLogRecords(Date fromDate, Date toDate, Event event, String pidFilter,
-			Integer start, Integer count) throws InvalidToken, InvalidRequest,
-			ServiceFailure, NotAuthorized, NotImplemented, InsufficientResources {
-
-		return getLogRecords(null, fromDate, toDate, event, pidFilter, start, count);
+	public Node getCapabilities() throws NotImplemented, ServiceFailure {
+		throw new NotImplemented("0000", "The CN capabilities are not stored in Metacat.");
 	}
 	
+	/**
+     * A method to notify the Coordinating Node that the authoritative copy of 
+     * system metadata on the Authoritative Member Node has changed.
+     * 
+     * @param session   Session information that contains the identity of the 
+     *                  calling user as retrieved from the X.509 certificate 
+     *                  which must be traceable to the CILogon service.
+     * @param serialVersion   The serialVersion of the system metadata
+     * @param dateSysMetaLastModified  The time stamp for when the system metadata was changed
+     * @throws NotImplemented
+     * @throws ServiceFailure
+     * @throws NotAuthorized
+     * @throws InvalidRequest
+     * @throws InvalidToken
+     */
 	@Override
-	public boolean hasReservation(Subject subject, Identifier pid)
-			throws InvalidToken, ServiceFailure, NotFound, NotAuthorized,
-			NotImplemented, InvalidRequest, IdentifierNotUnique {
+    public boolean systemMetadataChanged(Session session, Identifier pid,
+        long serialVersion, Date dateSysMetaLastModified) 
+        throws NotImplemented, ServiceFailure, NotAuthorized, InvalidRequest,
+        InvalidToken {
+        
+        // cannot be called by public
+        if (session == null) {
+        	throw new InvalidToken("2183", "No session was provided.");
+        }
 
-		return hasReservation(null, subject, pid);
-	}
-	
-	@Override
-	public Identifier registerSystemMetadata(Identifier pid, SystemMetadata sysmeta)
-			throws NotImplemented, NotAuthorized, ServiceFailure, InvalidRequest,
-			InvalidSystemMetadata, InvalidToken {
+        SystemMetadata currentLocalSysMeta = null;
+        SystemMetadata newSysMeta = null;
+        boolean allowed = false;
+        
+        // are we allowed to call this?
+        allowed = super.isAuthoritativeMNodeAdmin(session, pid);
+        
+        if (!allowed ) {
+            String msg = "The subject identified by " + session.getSubject().getValue() +
+              " is not authorized to call this service.";
+            throw new NotAuthorized("1331", msg);
+            
+        }
+        
+        // compare what we have locally to what is sent in the change notification
+        try {
+            currentLocalSysMeta = HazelcastService.getInstance().getSystemMetadataMap().get(pid);
+             
+        } catch (RuntimeException e) {
+            String msg = "SystemMetadata for pid " + pid.getValue() +
+              " couldn't be updated because it couldn't be found locally: " +
+              e.getMessage();
+            logMetacat.error(msg);
+            ServiceFailure sf = new ServiceFailure("1333", msg);
+            sf.initCause(e);
+            throw sf; 
+        }
+        
+        if (currentLocalSysMeta.getSerialVersion().longValue() < serialVersion ) {
+            try {
+            	
+                MNode mn = D1Client.getMN(currentLocalSysMeta.getAuthoritativeMemberNode());
+				newSysMeta = mn .getSystemMetadata(null, pid);
+            } catch (NotFound e) {
+                // huh? you just said you had it
+            	String msg = "On updating the local copy of system metadata " + 
+                "for pid " + pid.getValue() +", the AuthMN reports it is not found." +
+                " The error message was: " + e.getMessage();
+                logMetacat.error(msg);
+                ServiceFailure sf = new ServiceFailure("1333", msg);
+                sf.initCause(e);
+                throw sf;
+            }
+            
+            // update the local copy of system metadata for the pid
+            try {
+                HazelcastService.getInstance().getSystemMetadataMap().put(newSysMeta.getIdentifier(), newSysMeta);
+                logMetacat.info("Updated local copy of system metadata for pid " +
+                    pid.getValue() + " after change notification from the CN.");
+                
+                // TODO: consider inspecting the change for archive
+                // see: https://projects.ecoinformatics.org/ecoinfo/issues/6417
 
-		return registerSystemMetadata(null, pid, sysmeta);
-	}
+            } catch (RuntimeException e) {
+                String msg = "SystemMetadata for pid " + pid.getValue() +
+                  " couldn't be updated: " +
+                  e.getMessage();
+                logMetacat.error(msg);
+                ServiceFailure sf = new ServiceFailure("1333", msg);
+                sf.initCause(e);
+                throw sf;
+            }
+            
+            // submit for indexing
+            try {
+				MetacatSolrIndex.getInstance().submit(newSysMeta.getIdentifier(), newSysMeta, null, true);
+			} catch (Exception e) {
+                logMetacat.error("Could not submit changed systemMetadata for indexing, pid: " + newSysMeta.getIdentifier().getValue(), e);
+			}
+        }
+        
+        return true;
+        
+    }
 	
-	@Override
-	public Identifier reserveIdentifier(Identifier pid) throws InvalidToken,
-			ServiceFailure, NotAuthorized, IdentifierNotUnique, NotImplemented,
-			InvalidRequest {
-
-		return reserveIdentifier(null, pid);
-	}
-	
-	@Override
-	public boolean setObsoletedBy(Identifier pid, Identifier obsoletedByPid, long serialVersion)
-			throws NotImplemented, NotFound, NotAuthorized, ServiceFailure,
-			InvalidRequest, InvalidToken, VersionMismatch {
-
-		return setObsoletedBy(null, pid, obsoletedByPid, serialVersion);
-	}
-	
-	@Override
-	public DescribeResponse describe(Identifier pid) throws InvalidToken,
-			NotAuthorized, NotImplemented, ServiceFailure, NotFound {
-
-		return describe(null, pid);
-	}
-	
-	@Override
-	public InputStream get(Identifier pid) throws InvalidToken, ServiceFailure,
-			NotAuthorized, NotFound, NotImplemented {
-
-		return get(null, pid);
-	}
-	
-	@Override
-	public Checksum getChecksum(Identifier pid) throws InvalidToken,
-			ServiceFailure, NotAuthorized, NotFound, NotImplemented {
-
-		return getChecksum(null, pid);
-	}
-	
-	@Override
-	public SystemMetadata getSystemMetadata(Identifier pid) throws InvalidToken,
-			ServiceFailure, NotAuthorized, NotFound, NotImplemented {
-
-		return getSystemMetadata(null, pid);
-	}
-	
-	@Override
-	public ObjectList listObjects(Date startTime, Date endTime,
-			ObjectFormatIdentifier formatid, Boolean replicaStatus, Integer start, Integer count)
-			throws InvalidRequest, InvalidToken, NotAuthorized, NotImplemented,
-			ServiceFailure {
-
-		return listObjects(null, startTime, endTime, formatid, replicaStatus, start, count);
-	}
-	
-	@Override
-	public ObjectLocationList resolve(Identifier pid) throws InvalidToken,
-			ServiceFailure, NotAuthorized, NotFound, NotImplemented {
-
-		return resolve(null, pid);
-	}
-	
-	@Override
-	public ObjectList search(String queryType, String query) throws InvalidToken,
-			ServiceFailure, NotAuthorized, InvalidRequest, NotImplemented {
-
-		return search(null, queryType, query);
-	}
-	
-	@Override
-	public boolean deleteReplicationMetadata(Identifier pid, NodeReference nodeId,
-			long serialVersion) throws InvalidToken, InvalidRequest, ServiceFailure,
-			NotAuthorized, NotFound, NotImplemented, VersionMismatch {
-
-		return deleteReplicationMetadata(null, pid, nodeId, serialVersion);
-	}
-	
-	@Override
-	public boolean isNodeAuthorized(Subject targetNodeSubject, Identifier pid)
-			throws NotImplemented, NotAuthorized, InvalidToken, ServiceFailure,
-			NotFound, InvalidRequest {
-
-		return isNodeAuthorized(null, targetNodeSubject, pid);
-	}
-	
-	@Override
-	public boolean setReplicationPolicy(Identifier pid, ReplicationPolicy policy,
-			long serialVersion) throws NotImplemented, NotFound, NotAuthorized,
-			ServiceFailure, InvalidRequest, InvalidToken, VersionMismatch {
-
-		return setReplicationPolicy(null, pid, policy, serialVersion);
-	}
-	
-	@Override
-	public boolean setReplicationStatus(Identifier pid, NodeReference targetNode,
-			ReplicationStatus status, BaseException failure) throws ServiceFailure,
-			NotImplemented, InvalidToken, NotAuthorized, InvalidRequest, NotFound {
-
-		return setReplicationStatus(null, pid, targetNode, status, failure);
-	}
-	
-	@Override
-	public boolean updateReplicationMetadata(Identifier pid, Replica replica,
-			long serialVersion) throws NotImplemented, NotAuthorized, ServiceFailure,
-			NotFound, InvalidRequest, InvalidToken, VersionMismatch {
-
-		return updateReplicationMetadata(null, pid, replica, serialVersion);
-	}
-
-  @Override
-  public QueryEngineDescription getQueryEngineDescription(String arg0)
-          throws InvalidToken, ServiceFailure, NotAuthorized, NotImplemented,
-          NotFound {
-      throw new NotImplemented("4410", "getQueryEngineDescription not implemented");
-      
-  }
-
-  @Override
-  public QueryEngineList listQueryEngines() throws InvalidToken, ServiceFailure,
-          NotAuthorized, NotImplemented {
-      throw new NotImplemented("4420", "listQueryEngines not implemented");
-      
-  }
-
-  @Override
-  public InputStream query(String arg0, String arg1) throws InvalidToken,
-          ServiceFailure, NotAuthorized, InvalidRequest, NotImplemented, NotFound {
-      throw new NotImplemented("4324", "query not implemented");
-      
-  }
 }
